/******************************************************************
* main.h - Header for main window widget
*  
* 		blah blah goes here
*
* Created by:	isabella, 2011.11.02 - 06:42:43am
* 
******************************************************************/	

#ifndef MAIN_H
#define MAIN_H

#include <qmainwindow.h>
#include <qsplitter.h>
#include <qaction.h>
#include <qmenu.h>

#include "qt-dft.h"
#include "qt-pulse.h"
#include "qt-funcgen.h"

// sloppy >_>;;
#define MW_DECAY_ENTRIES	18
static float	decayTbl[MW_DECAY_ENTRIES] = {
	0.00f,		// 0
	1.010f,		// 1
	1.025f,		// 1
	1.05f,		// 1
	1.10f,		// 1
	1.12f,
	1.14f,		// etc...
	1.16f,
	1.18f,		// etc...
	1.19f,		// etc...
	1.20f,		// etc...
	1.24f,		// etc...
	1.28f,		// etc...
	1.30f,		// etc...
	1.34f,		// etc...
	1.38f,		// etc...
	1.40f,		// etc...
	1.44f,		// etc...
};


// Class for Main window 
class FunctionWindow : public QMainWindow {
	Q_OBJECT

public:
	FunctionWindow(QWidget *parent = 0);
	~FunctionWindow();

private:
	FuncGen		*funcGen;
	FuncGenModule	*funcGenMod;

};


// Class for Main window 
class MainWindow : public QMainWindow {
	Q_OBJECT

public:
	MainWindow(QWidget *parent = 0);
	~MainWindow();

private:
	// Menu Stuffs ~_~
	QMenu		*fileMenu;

	QAction		*dftRangeInc;
	QAction		*dftRangeDec;
	QAction		*dftRangeReset;

	QAction		*dftOffsetInc;
	QAction		*dftOffsetDec;
	QAction		*dftOffsetReset;

	QAction		*dftChangeType;

	QAction		*dftChangeDecay;

	// Instances of our other classes :D
	PulseRecord	*record;
	DFT		*pDft;
	Scope		*pScope;
	QSplitter 	*splitter;
	FunctionWindow	*funcDialog;


	// Variable for decay rate setting...
	unsigned int	decayTblNdx;

	// Size of sample bufr
	size_t		sampleCount;

	// Sample buffer for raw interleaved PCM data
	dftSamplePtr_t 	sampleBufPtr;
	// Just left channel data
	dftSamplePtr_t 	sampleBufLPtr;
	// Just right channel data
	dftSamplePtr_t 	sampleBufRPtr;

	// Mono mix of input (and double bufr :p)
	dftSamplePtr_t 	sampleBufMonoPtr;
	// Sample rate (44100,48000, etc)
	int 		sampleRate;

public slots:
	// Menu Stuffs ~____~;
	void		changeType(void);
	void		changePeakDecayRate(void);

	// Set range
	void 		rangeInc(void);
	void 		rangeDec(void);
	void 		rangeReset(void);

	// Set Offset
	void 		offsetInc(void);
	void 		offsetDec(void);
	void 		offsetReset(void);


	// Recieve data ready notifs from sound system
	void		dataReady(void);
};

#endif
