/******************************************************************
* plot.h - Short Document description~
*  
* 		Longer description.. ................
*
* Created by:	isabella, 2011.09.26 - 11:57:30am
* 
******************************************************************/
#ifndef PLOT_H
#define PLOT_H

#include <qwidget.h>
#include <qimage.h>
#include <qpainter.h>

#include <QBoxLayout>
#include <QLineEdit>
#include <QLabel>
#include <QComboBox>
#include <QGroupBox>

#include <stdio.h>

#include "dft.h"
#include "qt-scope.h"

// How many audio channels we dealing with?
#define AUDIO_CH_COUNT		2

// Default sample rate?
#define DFT_DEFAULT_SAMPLE_RATE	44100
#define DFT_DEFAULT_SR_DIVISOR	14

// general purpose scaling function, cast output to please ^^ 
// value     - input value to be scaled
// maxValue  - maximum possible value of value
// valueType - variable type of value (used in a cast l8r)
// maxOutput - maximum possible output value 
#define dftScale(value, maxValue, maxOutput) ((double)(value) * ((double)(maxOutput) / (double)(maxValue)))


typedef struct _dftRgb_t {
	int	r;
	int	g;
	int	b;
} dftRgb_t, *dftRgbPtr_t;

#define DFT_RGB_TBL_SIZE	0x100

/*
 ! DFT Class
*/
class DFT : public QWidget	{
	Q_OBJECT
public:
	DFT(int sampleRate = 44100, size_t sampleLength = (DFT_DEFAULT_SAMPLE_RATE/DFT_DEFAULT_SR_DIVISOR), QWidget *parent = 0);
	~DFT();
	void 		paintEvent(QPaintEvent *event);
	void		resizeEvent(QResizeEvent * event);
	int		maxRange;	//mod this later
	int		offset;
	float		peakDecayRate;

public slots:
	void 		toFreq(dftSamplePtr_t sampleBuf);
//	void 		dataReady(void);

	int		setRange(int);
	int		getRange(void);

	int		setOffset(int);
	int		getOffset(void);

	dftType_t	setDftType(dftType_t dftType);
	dftType_t	getDftType(void);

	float		setPeakDecayRate(float);
	float		getPeakDecayRate(void);

private:
	unsigned int	sampleRate;
	size_t		sampleCount;
	dftPtr_t	pDft;
	QImage		*pBgImage;
	QPainter 	painter;
	int		graphHeight;
	dftRgb_t	rgbTbl[DFT_RGB_TBL_SIZE];
};


#endif
