/******************************************************************
* qt-funcgen.cpp - Function Generator Widget Source Code
*  
* 		This does what it says it does ;p
*
* Created by:	isabella, 2011.11.03 - 02:12:35am
* 
******************************************************************/

#include <QDebug>

#include "qt-funcgen.h"

int genSquare(float x) {
	int blah = (int)((x / M_PI)+M_PI_2);
	return((blah&1)?1:-1);
}

FuncGenModule::FuncGenModule(unsigned int sampleRate, QWidget *parent) : QWidget(parent) {
	Q_UNUSED(sampleRate) 
};

GenericFuncGen::GenericFuncGen(unsigned int sampleRate, QWidget *parent) : FuncGenModule(sampleRate, parent) {
	this->setAutoFillBackground(true);

	boxPtr = new QBoxLayout(QBoxLayout::LeftToRight);
	labelBoxPtr = new QBoxLayout(QBoxLayout::LeftToRight);

	freqTextPtr = new QLineEdit(this);
	QFontMetrics fontMetrix = freqTextPtr->fontMetrics();

	freqTextPtr->setFixedSize(fontMetrix.width("000000000"), fontMetrix.height()+4);

	freqLablePtr = new QLabel("&freq:", this);
	freqLablePtr->setBuddy(freqTextPtr);
	freqLablePtr->setFixedSize(fontMetrix.width("000000000"), fontMetrix.height()+4);

	labelBoxPtr->addWidget(freqLablePtr);
	boxPtr->addWidget(freqTextPtr);

	ampTextPtr = new QLineEdit(this);
	ampTextPtr->setFixedSize(fontMetrix.width("000000000"), fontMetrix.height()+4);

	ampLablePtr = new QLabel("&Amp:", this);
	ampLablePtr->setBuddy(ampTextPtr);
	ampLablePtr->setFixedSize(fontMetrix.width("000000000"), fontMetrix.height()+4);

	labelBoxPtr->addWidget(ampLablePtr);
	boxPtr->addWidget(ampTextPtr);

	phaseTextPtr = new QLineEdit(this);
	phaseTextPtr->setFixedSize(fontMetrix.width("000000000"), fontMetrix.height()+4);

	phaseLablePtr = new QLabel("&Phase:", this);
	phaseLablePtr->setBuddy(phaseTextPtr);
	phaseLablePtr->setFixedSize(fontMetrix.width("000000000"), fontMetrix.height()+4);

	labelBoxPtr->addWidget(phaseLablePtr);
	boxPtr->addWidget(phaseTextPtr);

	waveTypePtr = new QComboBox;
	waveTypePtr->addItem(tr("Sine"), 	0);
	waveTypePtr->addItem(tr("Cos"), 	1);
	waveTypePtr->addItem(tr("Square"), 	2);
	waveLabelPtr = new QLabel(tr("&Wave:"));
	waveLabelPtr->setBuddy(waveTypePtr);
	waveLabelPtr->setFixedSize(fontMetrix.width("000000000"), fontMetrix.height()+4);

	labelBoxPtr->addWidget(waveLabelPtr);
	boxPtr->addWidget(waveTypePtr);

	freqListPtr = new QBoxLayout(QBoxLayout::TopToBottom, this);
	freqListPtr->addLayout(labelBoxPtr);
	freqListPtr->addLayout(boxPtr);

	qDebug() << "in: " << __func__ << "()";
	
}


// Widget for generating waveforms and stuffs
FuncGen::FuncGen(QWidget *parent, unsigned int sampleRate) : QWidget(parent) {

	this->setAutoFillBackground(true);

	// Create some modules
	fGen1 = new GenericFuncGen(sampleRate, this);
	fGen2 = new GenericFuncGen(sampleRate, this);

	qDebug() << "in: " << __func__ << "()";

//freqListPtr->addStretch(1);

//	sourceGroupBox = new QGroupBox(tr("Function Generator"), this);
//	sourceGroupBox->setLayout(freqListPtr);
//	sourceGroupBox->setMinimumSize(1200, 325);
	
//	QBoxLayout( Direction dir, QWidget * parent = 0 )
//	QScrollBar *freqBar( Qt::Orientation orientation, QWidget * parent = 0 )
//	QLineEdit ( QWidget * parent = 0 )
}

#define SAMPLE_COUNT	4096
#define SAMPLE_RATE	2048

int FuncGen::read(dftSamplePtr_t sampleBuf, size_t bufrSize) {
	int	x;	
//	dftSample_t sampleBuf[SAMPLE_COUNT];
	Q_UNUSED(bufrSize) 
	// Shiite function generator >_>
	for(x=0; x < SAMPLE_COUNT; x++) {
		float	funcX = 0;

//		funcX = (sinf((float)x * dftFreq(99, SAMPLE_RATE)+(1.234)) * 7000.0f);

//		funcX += (sinf((float)x * dftFreq(1.0f, SAMPLE_RATE)+(0.0f)) * dft2Gainf(75.0f));

		funcX += (sinf((float)x * dftFreq(305.0f, SAMPLE_RATE)+(3.231f)) * dft2Gainf(40.0f));

		funcX += (sinf((float)x * dftFreq(50.0f, SAMPLE_RATE)+(-0.0f)) * dft2Gainf(80.0f));

		funcX += (sinf((float)x * dftFreq(100.0f, SAMPLE_RATE)+(-1.234f)) * dft2Gainf(80.0f));

	//	funcX += (float)((rand()%65536)-32768)/1.5f;

//			funcX = (float)((((x/1)+0)%64)-32)*-2;
//		funcX += ((float)genSquare(x * dftFreq(20.0f, SAMPLE_RATE)+(0.0f))) * 8000.0;

		sampleBuf[x] = (dftSample_t)funcX;
	};
	return(1);
}

FuncGen::~FuncGen() {

}

