#ifndef QT_FUNCGEN_H
#define QT_FUNCGEN_H
/******************************************************************
* qt-funcgen.h - Function Generator Widget
*  
* 		(needs work ~_~)
*
* Created by:	isabella, 2011.11.03 - 02:10:28am
* 
******************************************************************/

#include <qwidget.h>
#include <QBoxLayout>
#include <QLineEdit>
#include <QLabel>
#include <QComboBox>
#include <QGroupBox>

#include "qt-dft.h"


// Virtual base for interfacing with various types of func gen modules?
class FuncGenModule : public QWidget {
	Q_OBJECT
public:
	FuncGenModule(unsigned int sampleRate = 44100, QWidget *parent = 0);
//	~FuncGen();

	//Should create sample bufr type (rate, bufr *, size, offset)

	// Generate function data for the defined interval, from x+offset to x+offset+size
	void		generate(unsigned int x, dftSamplePtr_t bufr, size_t size, unsigned int offset);
private:
	unsigned int	sampleRate;

};

class GenericFuncGen : public FuncGenModule {
	Q_OBJECT
public:
	GenericFuncGen(unsigned int sampleRate = 44100, QWidget *parent = 0);
//	~GenericFuncGen();

	void		generate(unsigned int x, dftSamplePtr_t bufr, size_t bufrSize);

private:
	QBoxLayout 	*boxPtr;
	QBoxLayout	*labelBoxPtr;
	QBoxLayout	*freqListPtr;

	QLabel		*freqLablePtr; 
	QLabel		*ampLablePtr;
	QLabel		*phaseLablePtr;

	QLineEdit	*freqTextPtr;
	QLineEdit	*ampTextPtr;
	QLineEdit	*phaseTextPtr;

	QComboBox	*waveTypePtr;
	QLabel		*waveLabelPtr;
};


// Widget for generating complex functions (combining multiple waves/sources)
class FuncGen : public QWidget {
	Q_OBJECT
public:
	FuncGen(QWidget *parent = 0, unsigned int sampleRate = 44100);
	~FuncGen();
	int		read(dftSamplePtr_t bufr, size_t bufrSize);
//	void 		paintEvent(QPaintEvent *event);
private:
//	QImage 		*plotImage;
	int		sampleRate;

	FuncGenModule	*fGen1;
	FuncGenModule	*fGen2;
	QGroupBox	*sourceGroupBox;

//	QList<TYPE>	waveList;

};

#endif

