/******************************************************************
* pa-record.h - qt-record headdah
*  
* 		Longer description.. ................
*
* Created by:	isabella, 2011.11.07 - 01:20:51pm
* 
******************************************************************/

#ifndef PARECORD_H
#define PARECORD_H

#include <qwidget.h>
#include <QThread>
#include <QDebug>

#include <pulse/simple.h>
#include <pulse/error.h>

#include "dft.h"

/*
 ! PulseAudio Record
*/
class PulseRecord : public QThread {
	Q_OBJECT
public:
	PulseRecord(dftSamplePtr_t bufr, size_t bufrSize, unsigned int sampleRate, size_t channels);
	~PulseRecord();

	void 		run();

signals:
	void 		dataReady(void);

private:
	dftSamplePtr_t 	bufr;
	size_t 		bufrSize;
	unsigned int	sampleRate;
	unsigned int	channels;
	
	// Instance of the PA object
	pa_simple 	*s;
	pa_sample_spec 	ss;
};


/*
 ! PulseAudio Playback
*/
class PulsePlayback : public QThread {
	Q_OBJECT
public:
	PulsePlayback(dftSamplePtr_t bufr, size_t bufrSize, unsigned int sampleRate, size_t channels);
	~PulsePlayback();

	void	run();
	int	write(dftSamplePtr_t pBufr = NULL, size_t bufrSize = 0);

signals:
	void	dataRequest(void);

private:
	dftSamplePtr_t	bufr;
	size_t		bufrSize;
	unsigned int	sampleRate;
	unsigned int	channels;

	// Instance of the PA object
	pa_simple	*s;
	pa_sample_spec	ss;
};
#endif
