/******************************************************************
* qt-scope.h - QT Based oscilloscope widget
*  
* 		Longer description.. ................
*
* Created by:	isabella, 2011.10.29 - 12:51:51am
* 
******************************************************************/

#ifndef QT_SCOPE_H
#define QT_SCOPE_H

//Need some types from here  >_>
#include "dft.h"
#include <qwidget.h>
#include <qpainter.h>

/*
 ! Oscillioscope 
*/

#define SCOPE_MAX_TRACES	0x10

typedef	struct _scopeTrace_t {
	// Number of s16 samples
	unsigned int	sampleCount;
	// Ptr to sample Bufr
	dftSamplePtr_t	pSampleBuf;
	// Trace color
	QColor	color;
} scopeTrace_t, *scopeTracePtr_t;


// Simple Scope Widget
class Scope : public QWidget {
	Q_OBJECT
public:
	Scope(QWidget *parent = 0);
	void 	paintEvent(QPaintEvent *event);
	void	resizeEvent(QResizeEvent * event);
	void	removeTrace(unsigned int index);
	void	addTrace(unsigned int index, dftSamplePtr_t pSampleBuf, size_t sampleCount, QColor);

public slots:
	void 		dataReady(void);

private:
	scopeTrace_t 	pTraces[SCOPE_MAX_TRACES];
	QImage		*pBgImage;
	QImage		*pOverlayImage;
	QPainter 	painter;
};

#endif
